/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail;

import javax.servlet.jsp.JspTagException;

/**
 * <p>
 * BreadCrumbException is thrown in all cases where the BreadCrumbTrailTag cannot correctly parse,
 * format and draw bread crumb trail. NodeDiscovery and PathDiscovery implementations will throw this exception too.
 * The only other exception thrown by this component is IllegalArgumntException.
 * </p>
 *
 * <p>
 * If silentErrors is true, this exception is caught and BreadCrumpTrailTag ends without drawing tag.
 * </p>
 *
 * <p>
 * <b>Thread Safety: </b> This class is immutable and therefore thread safe.
 * </p>
 *
 * @author Pops, TCSDEVELOPER
 * @version 2.0
 * @since 1.0
 *
 */
public class BreadCrumbException extends JspTagException {
    /**
     * <p>
     * Constructs the exception from the given message.
     * </p>
     *
     * @param message The possibly null, possibly empty message
     *
     * @since 1.0
     */
    public BreadCrumbException(String message) {
        super(message);
    }

    /**
     * <p>
     * Constructs the exception from the given message and inner exception.
     * </p>
     *
     * @param message The possibly null, possibly empty message
     * @param cause The possibly null inner exception
     *
     * @since 2.0
     */
    public BreadCrumbException(String message, Throwable cause) {
        super(message, cause);
    }
}
