/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail;

import java.util.Hashtable;

import javax.servlet.jsp.tagext.TagData;
import javax.servlet.jsp.tagext.VariableInfo;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.framework.Test;

/**
 * <p>
 * Unit test cases for BreadCrumbTrailTagExtraInfo.
 * </p>
 *
 * @author TCSDEVELOPER
 * @version 2.0
 */

public class BreadCrumbTrailTagExtraInfoTests extends TestCase {
    /**
     * <p>
     * BreadCrumbTrailTagExtraInfo instance for testing.
     * </p>
     *
     */
    private BreadCrumbTrailTagExtraInfo tei;

    /**
     * <p>
     * Setup test environment.
     * </p>
     *
     */
    protected void setUp() {
        tei = new BreadCrumbTrailTagExtraInfo();
    }

    /**
     * <p>
     * Tears down test environment.
     * </p>
     *
     */
    protected void tearDown() {
        tei = null;
    }

    /**
     * <p>
     * Return all tests.
     * </p>
     *
     * @return all tests
     */
    public static Test suite() {
        return new TestSuite(BreadCrumbTrailTagExtraInfoTests.class);
    }

    /**
     * <p>
     * Tests ctor BreadCrumbTrailTagExtraInfo#BreadCrumbTrailTagExtraInfo() for accuracy.
     * Expects tei is created successfully.
     * </p>
     */
    public void testCtor() {
        assertNotNull("Failed to create new BreadCrumbTrailTagExtraInfo instance.", tei);
    }

    /**
     * <p>
     * Tests BreadCrumbTrailTagExtraInfo#getVariableInfo(TagData) for accuracy.
     * Expects getVariableInfo() returns correct VariableInfo instances.
     * </p>
     */
    public void testGetVariableInfo() {
        TagData tagData = new TagData(new Hashtable());

        VariableInfo[] vis = tei.getVariableInfo(tagData);

        assertEquals("Expects the returned array has two elements.", 2, vis.length);

        VariableInfo vi1 = new VariableInfo(BreadCrumbTrailTag.BREADCRUMB_FORMAT_NODE,
                BreadCrumbNode.class.getName(), true, VariableInfo.NESTED);
        VariableInfo vi2 = new VariableInfo(BreadCrumbTrailTag.BREADCRUMB_FORMAT_STYLE_CLASS,
                String.class.getName(), true, VariableInfo.NESTED);

        assertTrue("Expects equal VariableInfo instance.", isVariableInfoEqual(vi1, vis[0]));
        assertTrue("Expects equal VariableInfo instance.", isVariableInfoEqual(vi2, vis[1]));
    }

    /**
     * <p>
     * Returns true if the given two VariableInfo equals, otherwise return false.
     * </p>
     *
     * @param vi1 VariableInfo instance.
     * @param vi2 VariableInfo instance.
     *
     * @return true if the given two VariableInfo equals, otherwise return false.
     */
    private boolean isVariableInfoEqual(VariableInfo vi1, VariableInfo vi2) {
        if (!vi1.getClassName().equals(vi2.getClassName())) {
            return false;
        }
        if (!vi1.getVarName().equals(vi2.getVarName())) {
            return false;
        }
        if (vi1.getDeclare() != vi2.getDeclare()) {
            return false;
        }
        if (vi1.getScope() != vi2.getScope()) {
            return false;
        }
        return true;
    }

}