/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail;

import javax.servlet.jsp.PageContext;

/**
 * <p>
 * This class implements the NodeDiscovery interface.
 * </p>
 *
 * <p>
 * In getCurrentNode method, it will always return a node with "Help" title and "/forums" url.
 * </p>
 *
 * @author TCSDEVELOPER
 * @version 2.0
 *
 */
public class DummyNodeDiscovery implements NodeDiscovery {
    /**
     * <p>
     * Constructs a DummyNodeDiscovery using no arguments.
     * </p>
     *
     */
    public DummyNodeDiscovery() {
    }

    /**
     * <p>
     * Always returns a node with "Help" title and "/forums" url.
     * </p>
     *
     * @param pageContext page context.
     *
     * @return a node with "Help" title and "/forums" url.
     */
    public BreadCrumbNode getCurrentNode(PageContext pageContext) {
        return new BreadCrumbNode("/forums", "Help");
    }

}
