/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.web.ui.tag.breadcrumbtrail.nodediscovery;

import javax.servlet.jsp.tagext.BodyTagSupport;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.framework.Test;

/**
 * <p>
 * Unit test cases for InlineTextNodeDiscoveryTag.
 * </p>
 *
 * <p>
 * For in-container tests, please see NodeDiscoveryInContainerTests.
 * </p>
 *
 * @author TCSDEVELOPER
 * @version 2.0
 */
public class InlineTextNodeDiscoveryTagTests extends TestCase {
    /**
     * <p>
     * InlineTextNodeDiscoveryTag instance for testing.
     * </p>
     */
    private InlineTextNodeDiscoveryTag tag;

    /**
     * <p>
     * Setup test environment.
     * </p>
     *
     */
    protected void setUp() {
        tag = new InlineTextNodeDiscoveryTag();
    }

    /**
     * <p>
     * Tears down test environment.
     * </p>
     *
     */
    protected void tearDown() {
        tag = null;
    }

    /**
     * <p>
     * Return all tests.
     * </p>
     *
     * @return all tests
     */
    public static Test suite() {
        return new TestSuite(InlineTextNodeDiscoveryTagTests.class);
    }

    /**
     * <p>
     * Tests ctor InlineTextNodeDiscoveryTag#InlineTextNodeDiscoveryTag() for accuracy.
     * Expects tag is successfully created.
     * </p>
     */
    public void testCtor() {
        assertNotNull("Failed to create new InlineTextNodeDiscoveryTag instance.", tag);
    }

    /**
     * <p>
     * Tests InlineTextNodeDiscoveryTag#doStartTag() for accuracy.
     * Expects *EVAL_BODY_BUFFERED* returned.
     * </p>
     */
    public void testDoStartTag() {
        int value = tag.doStartTag();

        assertEquals("Expects the int value that EVAL_BODY_BUFFERED represents.", BodyTagSupport.EVAL_BODY_BUFFERED,
                value);
    }

    /**
     * <p>
     * Tests InlineTextNodeDiscoveryTag#getTitle() for accuracy.
     * Expects the default value for title is null.
     * </p>
     */
    public void testGetTitle() {
        assertNull("Expect title is initially null.", tag.getTitle());
    }

    /**
     * <p>
     * Tests InlineTextNodeDiscoveryTag#setTitle(String) for accuracy.
     * Expects title is correctly set.
     * </p>
     */
    public void testSetTitle() {
        tag.setTitle("Main");

        assertEquals("Failed to get correct title.", "Main", tag.getTitle());
    }

    /**
     * <p>
     * Tests InlineTextNodeDiscoveryTag#setTitle(String) for accuracy.
     * It tests the case that when title is null and expects success.
     * </p>
     */
    public void testSetTitle_NullTitle() {
        tag.setTitle(null);

        assertNull("Expect title is null.", tag.getTitle());
    }

    /**
     * <p>
     * Tests InlineTextNodeDiscoveryTag#setTitle(String) for accuracy.
     * It tests the case that when title is empty and expects success.
     * </p>
     */
    public void testSetTitle_EmptyTitle() {
        tag.setTitle(" ");

        assertNull("Expect title is null.", tag.getTitle());
    }
}